/*
 *  Copyright (c) 2008 Cyrille Berger <cberger@cberger.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _GTLCORE_FUNCTION_CALLER_P_H_
#define _GTLCORE_FUNCTION_CALLER_P_H_

#include <vector>
#include <GTLCore/Value.h>

namespace llvm {
  class Function;
}

namespace GTLCore {
  class Value;
  class Function;
  class ModuleData;
  /**
   * @internal
   * @ingroup GTLCore
   * This class is part of the private API of OpenCTL.
   * This is use to provide fast and efficient call to CTL functions,
   * unlike what llvm's JIT provides.
   */
  class FunctionCaller {
    public:
      FunctionCaller(llvm::Function*, const Function*, ModuleData* _data);
      ~FunctionCaller();
      GTLCore::Value call(const std::vector<GTLCore::Value>& arguments ) ;
    private:
      struct Private;
      Private* const d;
  };
  
}

#endif
